/**
 * call()
 * Let js pass event and data to client
 * and wait for callback
 * @export
 * @param {string} type        - name of event
 * @param {*} [params={}]      - data object to pass to client
 * @param {{                   - options
 *     callbackId?: string        - use randomly string by default, use `''` if client needs
 *     once?: boolean             - will remove listener once callback is fired if is true
 *   }} [options={
 *     once: true,
 *   }]
 * @returns {Promise<any>}
 */
export default function call(type: string, params?: any, options?: {
    callbackId?: string;
    once?: boolean;
}): Promise<any>;
