import { LiffCore } from '../../liff';
declare type PluginName = 'bluetooth' | 'advertisement';
interface PluginModule {
    default: (liff: LiffCore) => {} | Promise<{}>;
}
export interface Plugin {
    checkSupport: (liff: LiffCore) => boolean;
    load: () => Promise<PluginModule> | PluginModule;
    errorMessage: string;
}
export declare type InitPlugins = (plugins: PluginName[]) => Promise<void[]>;
/**
 * Verify and load and initialize plugins.
 * @param   {PluginNames}  plugins - string array of plugin names
 * @returns {Promise<any>}
 */
export default function createInitPlugins(liff: LiffCore, verification: any): InitPlugins;
export {};
