import { ElementType } from './typeHelpers';
export declare const UNKNOWN = "UNKNOWN";
export declare const UNAUTHORIZED = "UNAUTHORIZED";
export declare const INVALID_ARGUMENT = "INVALID_ARGUMENT";
export declare const INIT_FAILED = "INIT_FAILED";
export declare const FORBIDDEN = "FORBIDDEN";
export declare const INVALID_CONFIG = "INVALID_CONFIG";
export declare const INVALID_ID_TOKEN = "INVALID_ID_TOKEN";
export declare const CREATE_SUBWINDOW_FAILED = "CREATE_SUBWINDOW_FAILED";
export declare const EXCEPTION_IN_SUBWINDOW = "EXCEPTION_IN_SUBWINDOW";
export declare const LIFF_EVENT = "liffEvent";
export declare const STORE_KEY = "LIFF_STORE";
export declare const PERMANENT_LINK_ORIGIN: string;
export declare const TORIMOCHI_URL = "https://torimochi.line-apps.com/1/req";
export declare const STORE_OBJECT: {
    readonly ACCESS_TOKEN: "accessToken";
    readonly ID_TOKEN: "IDToken";
    readonly DECODED_ID_TOKEN: "decodedIDToken";
    readonly FEATURE_TOKEN: "featureToken";
    readonly FEATURES: "features";
    readonly LOGIN_TMP: "loginTmp";
    readonly CONFIG: "config";
    readonly CONTEXT: "context";
    readonly EXPIRES: "expires";
    readonly RAW_CONTEXT: "rawContext";
    readonly CLIENT_ID: "clientId";
};
export declare const STORE_SUBKEY_IS_IN_CLIENT = "isInClient";
export declare const LIFF_ATTR_DOM = "data-l-{0}";
export declare enum ROUTER_MODE {
    NONE = "none",
    HASH = "hash",
    HISTORY = "history"
}
export declare const CREDENTIAL_KEYS: readonly ["context_token", "feature_token", "access_token", "id_token", "client_id"];
export declare type CREDENTIAL_OBJECTS = {
    [key in ElementType<typeof CREDENTIAL_KEYS>]: string | null;
};
export declare const MAX_NUM_OF_SEND_MESSAGES = 5;
export declare const IFRAME_OPEN_ANIMATION_DURATION = 400;
